//////////////////////////////////////////////////////////////////////////////////////////////////
// File Name: Colony.cs
//      Date: 06/01/2006
// Copyright (c) 2006 Michael LaLena. All rights reserved.  (www.lalena.com)
// Permission to use, copy, modify, and distribute this Program and its documentation,
//  if any, for any purpose and without fee is hereby granted, provided that:
//   (i) you not charge any fee for the Program, and the Program not be incorporated
//       by you in any software or code for which compensation is expected or received;
//   (ii) the copyright notice listed above appears in all copies;
//   (iii) both the copyright notice and this Agreement appear in all supporting documentation; and
//   (iv) the name of Michael LaLena or lalena.com not be used in advertising or publicity
//          pertaining to distribution of the Program without specific, written prior permission. 
///////////////////////////////////////////////////////////////////////////////////////////////////
using System;
using System.Collections.Generic;
using System.Drawing;

namespace AntGP
{
	/// <summary>
	/// The colony is simply a list of ants.
	/// </summary>
	public class Colony : List<Ant>
	{
        /// <summary>
        /// Default constructor.
        /// </summary>
		public Colony()
		{
		}

        /// <summary>
        /// Constructor that will make the given number of ants and set their position on the map.
        /// </summary>
        /// <param name="numberOfAnts">The number of ants to create in the colony.</param>
        /// <param name="map">The map to place the ants on.</param>
        public Colony(int numberOfAnts, Map map)
        {
            for (int i = 0; i < numberOfAnts; i++)
            {
                this.Add(new Ant(map.NestLocation, Compass.CompassDirection.North, map));
            }
        }

        public long TotalMovement
        {
            get
            {
                long totalMovement = 0;
                foreach (Ant ant in this)
                {
                    totalMovement += ant.TotalMovement;
                }

                return totalMovement;
            }
        }
    }
}
